procedure TSRDBApp.InitMenuBar;
 var R: TRect;
 begin
  GetExtent(R); R.B.Y := R.A.Y + 1;
  MenuBar := New(PSMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
      NewItem('~U~se',  'Enter',kbEnter,cmUse,hcNoContext,
      NewItem('~O~rder','F4',   kbF4, cmOrder,hcNoContext,
      NewItem('~P~art', 'F5',   kbF5, cmPart, hcNoContext,
      NewLine(
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil)))))
      ),
    NewSubMenu('~R~ecord',hcNoContext, NewMenu(
      NewItem('~N~ew',   'F1',  kbF1, cmNewRec, hcNoContext,
      NewItem('~E~dit',  'F2',  kbF2, cmEditRec,hcNoContext,
      NewItem('~D~uplicate','F8',kbF8,cmDupRec, hcNoContext,
      NewLine(
      NewItem('E~r~ase',   'F3',kbF3,cmDelRec,hcNoContext,
      NewItem('~M~ix with','F7',kbF7,cmMixRec,hcNoContext,
      NewLine(
      NewItem('~L~inks','F6',kbF6,cmRecLinks,hcNoContext,
      nil))))))))
     ),
    NewSubMenu('~S~election',hcNoContext, NewMenu(
      NewItem('create ~F~ull',  'F9', kbF9, cmFullSel, hcNoContext,
      NewItem('by ~Q~uery',     'F10',kbF10,cmQuerySel,hcNoContext,
      NewItem('by ~L~inks (join)','Shift-F6',kbShiftF6,cmLinksSel,  hcNoContext,
      NewItem('by P~r~ojection','Shift-F7',kbShiftF7,cmProjectSel,hcNoContext,
      NewLine(
      NewItem('~S~ort',         'Shift-F4',kbShiftF4,cmSortSel,  hcNoContext,
      NewItem('~T~ext output',  'Shift-F1',kbShiftF1,cmPrintSel, hcNoContext,
      NewItem('~C~olumn counts','Shift-F2',kbShiftF2,cmCountSumm,hcNoContext,
      nil))))))))
     ),
    NewSubMenu('~O~ther',hcNoContext,NewMenu(
      NewItem('~L~icense','',kbNoKey,cmAbout,hcNoContext,
      nil)),
    nil))))
  )));
 end;

procedure TSRDBApp.InitStatusLine;
 var R: TRect;
 function New_Esc(P:PStatusItem): PStatusItem;
  begin New_Esc:=NewStatusKey('~Esc~ Close', kbEsc, cmClose,P) end;
 function New_Can(P:PStatusItem): PStatusItem;
  begin New_Can:=NewStatusKey('~Esc~ Cancel', kbEsc, cmCancel,P) end;
 function New_Sel(P:PStatusItem): PStatusItem;
  begin New_Sel:=New_Can(NewStatusKey('~Enter~ Select',kbEnter,cmClose,P)) end;
 function New_ER(P:PStatusItem): PStatusItem;
  begin New_ER:=New_Can(NewStatusKey('~F1~ Accept',kbF1,cmOK,P)) end;
 function New_CanClose(P:PStatusItem): PStatusItem;
  begin New_CanClose:=New_Can(NewStatusKey('~F1~ Accept',kbF1,cmClose,P)) end;
 function QuerySortList(P:PStatusItem): PStatusItem;
  begin QuerySortList:=New_CanClose(
   NewStatusKey('~F2~ Add',kbF2,cmAddSortEl,
   NewStatusKey('~F3~ Del',kbF3,cmDelSortEl,
   P)))
  end;
 function NextPrevWinKeys: PStatusItem;
  begin NextPrevWinKeys:=
   NewStatusKey('', kbTab,      cmNext,
   NewStatusKey('', kbShiftTab, cmPrev, nil))
  end;
 const
  uskBrouse = 0;
  uskSelect = 1;
  uskInclud = 2;
  uskSetBrs = 3;
 function UseStatusKeys(usk:byte):PStatusItem;
  function Tail_0:PStatusItem;
   begin Tail_0:=
    NewStatusKey('~F7~ Mix',kbF7,cmMixRec,
    NewStatusKey('~F8~ Dup',kbF8,cmDupRec,
    NextPrevWinKeys))
   end;
  function Tail_1:PStatusItem;
   var Tail:PStatusItem;
   begin
    case usk of
     uskBrouse,uskInclud,uskSetBrs:Tail:=
     NewStatusKey('~F6~ Links', kbF6,cmRecLinks,Tail_0);
     uskSelect:Tail:=Tail_0;
    end;
    case usk of
     uskBrouse,uskSelect:Tail_1:=
     NewStatusKey('~F4~ Order', kbF4, cmOrder,
     NewStatusKey('~F5~ Part',  kbF5, cmPart,
     Tail));
     uskInclud,uskSetBrs:Tail_1:=Tail;
    end;
   end;
  begin
   UseStatusKeys:=
    NewStatusKey('~F1~ New',   kbF1, cmNewRec,
    NewStatusKey('~F2~ Edit',  kbF2, cmEditRec,
    NewStatusKey('~F3~ Del',   kbF3, cmDelRec,
    Tail_1)))
  end;
 begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
   NewStatusDef(1800, 1899, { Colapse File List }
    New_CanClose(
     NewStatusKey('~F2~ equvalent field',kbF2,cmSetSorsFld,
     NewStatusKey('~F3~ initial value', kbF3,cmSetFldValue,nil))),
   NewStatusDef(1700, 1799, { Edit Query List }
    QuerySortList(
     NewStatusKey('~F4~ Relation',kbF4,cmToggle,
     NewStatusKey('~F5~ Value',   kbF5,cmChFldVal,Nil))),
   NewStatusDef(1600, 1699, { Edit Sort List }
    QuerySortList(NewStatusKey('~F4~ Toggle',kbF4,cmToggle,Nil)),
   NewStatusDef(1500, 1599, { Field select }
    New_Sel(NewStatusKey('~F2~ Expand/Colapse',kbF2,cmExpColaps,Nil)),
   NewStatusDef(1450, 1499, { Included Brouser }
    New_Esc(UseStatusKeys(uskInclud)),
   NewStatusDef(1400, 1449, { Selection brouser }
    New_Esc(UseStatusKeys(uskSetBrs)),
   NewStatusDef(1350, 1399, { Record selector }
    New_Sel(UseStatusKeys(uskSelect)),
   NewStatusDef(1300, 1349, { Record brouser }
    New_Esc(UseStatusKeys(uskBrouse)),
   NewStatusDef(1200, 1299, { Field brouser }
    New_Esc(
     NewStatusKey('~F1~ New',  kbF1, cmNewFld,
     NewStatusKey('~F2~ Edit', kbF2, cmEditFld,
     NewStatusKey('~F3~ Erase', kbF3, cmDelFld,
     NextPrevWinKeys)))),
   NewStatusDef(1000, 1009, { Edit record part of record }
    New_ER(nil),
   NewStatusDef(1010, 1019, { Edit pointer part of record }
    New_ER(NewStatusKey('~F2~ Edit', kbF2, cmEditPtr,Nil)),
   NewStatusDef(1020, 1029, { File brouser }
    NewStatusKey('~Alt-X~ Exit',kbAltX,cmQuit,
    NewStatusKey('~Enter~ Use',kbEnter,cmUse,
    NextPrevWinKeys)),
   NewStatusDef(1100, 1110, { Simple chois }
    New_Sel(Nil),
   NewStatusDef($0000, $FFFF,
    NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,Nil),
   nil))))))))))))))));
 end;

procedure TSRDBApp.DoAboutBox;
begin MessageBox(
  #3+'SRDB client for Linux OS, Ver 0.5.00'+#13+
  #3+'(c) Skelet (G. Georgiev) in terms of'+#13+
  #3+'GNU General Public License, Mar 1999'+#13+
  #3+'Email:        skelet@osc-sz.inetg.bg',
  nil, mfInformation or mfOKButton);
end;

