unit cli_proc;
{$I options.pp}
interface

uses
 Views;

const
 MaxProcWin = 63;
 CurrentSes:word = 0;

type
 PLocalProcess = ^TLocalProcess;
 TLocalProcess = object
  MyPort:byte; { }
  MyWin:PView; { Browser or Dialog View }
  constructor Init(aWin:PView; var Sucess:boolean);
  destructor Done;
  procedure InitSesion;
  procedure Question(cmd:byte; var Data; Size:word);
  procedure Answer(cmd:byte; var Data); virtual;
 end;
 TNetPort = record
  SesId:word; { Unique sesion Id for local process }
  PWin:PLocalProcess; { pointer to process object }
 end;

var
 Ports:array[0..MaxProcWin] of TNetPort;

implementation

uses
 Common, TCP_Clnt;

var PortId:byte;

constructor TLocalProcess.Init(aWin:PView; var Sucess:boolean);
 begin
  MyPort:=0; MyWin:=aWin; Sucess:=True;
  while (MyPort<=MaxProcWin) and (Ports[MyPort].PWin<>Nil) do Inc(MyPort);
  if MyPort>MaxProcWin then Sucess:=False else begin
   Ports[MyPort].PWin:=@Self; { Lock port }
   InitSesion;
  end;
 end;
procedure TLocalProcess.InitSesion;
 begin
  Ports[MyPort].SesId:=CurrentSes;
  Inc(CurrentSes);
 end;
procedure TLocalProcess.Question(cmd:byte; var Data; Size:word);
 var Buf:TNetBuf; Head:TCliWinHead absolute Buf;
 begin
  with Head do begin
   Port:=MyPort; SesId:=Ports[MyPort].SesId; PCmd:=cmd end;
  Move(Data,Buf[SizeOf(Head)],Size);
  SendToServer(ncLocProcQuest,Buf,Size+SizeOf(Head));
 end;
procedure TLocalProcess.Answer(cmd:byte; var Data);
 begin end;
destructor TLocalProcess.Done;
 begin if MyPort<=MaxProcWin then Ports[MyPort].PWin:=Nil end;

begin
 for PortId:=0 to MaxProcWin do Ports[PortId].PWin:=Nil;
end.

