{******************************************}
{                                          }
{   Turbo Vision Version for SRDB Client   }
{   Copyright (c) 1998 by Skelet Software  }
{                                          }
{******************************************}

program SRDBc;

{$I options.pp}

uses
 Str_def, Cli_app, common, screen;

procedure Help;
 begin
  Writeln;
  Writeln;
  Writeln(ErrStr(esSRDB_Help_0));
  Writeln;
  Writeln;
  Writeln(ErrStr(esSRDB_Help_1));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_2));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_3));
  Writeln(ErrStr(esSRDB_Help_4));
  Writeln(ErrStr(esSRDB_Help_5));
  Writeln(ErrStr(esSRDB_Help_6));
  Writeln;
  writeln('  -l or /L - Write client/server dialog to file trace.log');
  writeln('  -v:xx - Set terminal height to xx lines (in range 24..52)');
  Writeln;
  Halt;
 end;

var param:string; i:byte;

procedure SetVerSize;
 var i,l:integer;
 begin
  delete(param,1,3);
  val(param,l,i);
  if i=0 then begin
   if l<24 then l:=24;
   if l>52 then l:=50;
   screenH0:=l;
  end;
 end;

begin
 if ErrFileInit then begin
  Writeln;
  Writeln(ErrStr(esSRDB_Help_7));
  if paramcount>0 then for i:=1 to paramcount do begin
   param:=paramstr(i);
   if param='/?' then Help;
   if (param='/L') or (param='-l') then LogFileEnable:=True;
   if Pos('-v:',param)>0 then SetVerSize;
  end;
  SRDBApp.Init;
  SRDBApp.Run;
  SRDBApp.Done;
 end;
end.
