unit sr_eval;
{$I options.pp}
interface

uses Common;

procedure SetLimits(var TL:TlpLimits);
procedure SetBrLine(var DL:TlpDataLines; var DLA:TlpDataLineA; dy:byte);

implementation

uses
{ sr_conn, }
 date_lib, sk_types,
 sr_data, sr_recs,
 str_def;

procedure SetLimits(var TL:TlpLimits);
 var Fld:TFldRec; OK:boolean; PDF:PDataFile;
 procedure LongLimits;
  { Limits begin with N0,N1:longint }
  begin with TL do begin
   CurStart:=PDF^.FindFirst(IndexId,Limits[0],True);
   CurEnd:=PDF^.FindFirst(IndexId,Limits[SizeOf(longint)],False)+1;
  end end;
 procedure PntrLimits;
  { Limits begin with Pntr:longint }
  begin with TL do begin
   CurStart:=PDF^.FindFirst(IndexId,Limits[0],True);
   CurEnd:=PDF^.FindFirst(IndexId,Limits[0],False)+1;
  end end;
 procedure DateLimits;
  { Limits begin with Period:TPeriod }
  begin with TL do begin
   CurStart:=PDF^.FindFirst(IndexId,Limits[0],True);
   CurEnd:=PDF^.FindFirst(IndexId,Limits[SizeOf(DateRec)],False)+1;
  end end;
 procedure TextLimits;
  var ss,se:string;
  begin with TL do begin
   ss:=ClearSp(RecStr(Limits,Fld.Size)); se:=ss;
   RExpandStr(ss,Fld.Size,chr(0));
    CurStart:=PDF^.FindFirst(IndexId,ss[1],True);
   RExpandStr(se,Fld.Size,chr($FF));
    CurEnd:=PDF^.FindFirst(IndexId,se[1],False)+1;
  end end;
 begin with TL do begin
  PDF:=DFArr[FileId];
  { --- Eval LimitStr --- }
{$IFDEF Cir}
  LimitStr:='   ';
  if IndexId=$FF then LimitStr:=LimitStr+''
{$ENDIF} {$IFDEF Lat}
  LimitStr:=' Order by ';
  if IndexId=$FF then LimitStr:=LimitStr+'creation'
{$ENDIF}
   else begin
    LimitStr:=LimitStr+PDF^.FldName(IndexId);
    PDF^.Fields^.GetRec(IndexId,Fld);
   end;
  if Ltd
   then LimitStr:=LimitStr+' '+FldLimitStr(Fld,Limits)
   else begin
    {        Client, }
    {           }
    LimitStr:=LimitStr+ErrStr(esAllRecords0);
   end;
  { --- Eval Limit numbers --- }
  if Ltd then begin
   PDF^.Fields^.GetRec(IndexId,Fld);
   case Fld.FType of
    CFList,CFWord,CFLong:LongLimits;
    CFPntr:PntrLimits;
    CFDate:DateLimits;
    CFStr,CFName:TextLimits;
   end;
   CurEnd:=max(CurEnd,CurStart);
   if EvalWinInd
    then if RecInd<>-1 then begin
     OK:=True; WinInd:=PDF^.IndArr[IndexId]^.Find(RecInd,OK);
     if OK
      then if WinInd<CurStart
       then WinInd:=0
       else if WinInd>CurEnd
        then WinInd:=CurEnd-CurStart
        else Dec(WinInd,CurStart)
      else WinInd:=CurEnd-CurStart;
    end else WinInd:=CurEnd-CurStart
    else if WinInd=CurEnd-CurStart
     then RecInd:=-1
     else RecInd:=PDF^.IndArr[IndexId]^.GetV(WinInd+CurStart);
  end else begin
   CurStart:=0;
   if IndexId<>$FF then begin
    CurEnd:=PDF^.IndArr[IndexId]^.Data.Cnt;
    if EvalWinInd
     then if RecInd<>-1 then begin
      OK:=True; WinInd:=PDF^.IndArr[IndexId]^.Find(RecInd,OK);
      if not OK then WinInd:=CurEnd;
     end else WinInd:=CurEnd
     else if WinInd=CurEnd
      then RecInd:=-1
      else RecInd:=PDF^.IndArr[IndexId]^.GetV(WinInd);
   end else begin
    CurEnd:=PDF^.Data^.Length;
    if EvalWinInd
     then if RecInd<>-1 then WinInd:=RecInd else WinInd:=CurEnd
     else if WinInd=CurEnd then RecInd:=-1 else RecInd:=WinInd;
   end;
  end;
 end end;

{----------------------------------------------------------------------}

procedure SetBrLine(var DL:TlpDataLines; var DLA:TlpDataLineA; dy:byte);
 var IndId,FPtr:longint; PDF:PDataFile; PR:PBlock; Ln:string;
 begin
  with DL do begin
   PDF:=DFArr[FileId];
   IndId:=CurStart+WinStart+dy;
   if IndId>=CurEnd
    then FPtr:=-1
    else if IndexId=$FF
     then FPtr:=IndId
     else FPtr:=PDF^.IndArr[IndexId]^.GetV(IndId);
   with PDF^ do begin
    GetMem(PR,RecSize);
    if FPtr<>-1 then begin
     Data^.GetRec(FPtr,PR^);
     if PR^[0]<>$FF
      then Ln:=StdBrouseLine(FPtr,WinStart+dy,PR^,aExFld,false)
      else Ln:=' erased ';
    end else begin
     Ln:=StdBrouseLine(-1,-1,PR^,aExFld,false);
     ReplStr(Ln,{$IFDEF Cir} '<  >'  {$ENDIF}
                {$IFDEF Lat} '< nobody >' {$ENDIF},2);
    end;
    FreeMem(PR,RecSize);
   end;
  end;
  with DLA do begin
   SesId:=DL.SesId;
   WinDY:=dy; RecInd:=FPtr;
   BrStr:=copy(Ln,1,80);
  end;
 end;

end.
