unit sr_open;
{$I options.pp}
interface

const
 KrunchEnabled:boolean = True;

procedure OpenBase;

implementation

uses
{$IFDEF Turbo} Dos, Skl_defs, {$ENDIF}
{$IFDEF FPC} {Linux,} Sk_types, {Strings,} {$ENDIF}
 sr_data, common, Str_def;

const
 ProjFileName = 'Project.Def';
 FileStatusStr0:array[0..2] of string[4] = ('norm','temp','err?');

procedure OpenBase;
 var t:text; i:byte; DFNR:TDFNames;
 procedure KrunchFiles;
  var i,j:byte; Last,First:longint; PB,PD:PBlock; s:string[10];
  begin if FileCount>0 then for j:=0 to FileCount-1
   do with DFArr[j]^ do if Data^.Length>OpenLen then begin
     GetMem(PB,RecSize); GetMem(PD,RecSize);
     Last:=Data^.Length; First:=-1;
     Str(Last-OpenLen,s);
{$IFDEF Cir}
     Write(' '+s+'   '+LName+' ');
{$ENDIF}
{$IFDEF Lat}
     Write('Crunching '+s+' records from '+LName+' ');
{$ENDIF}
     while Last>OpenLen do begin
      write('.');
      Dec(Last); Data^.GetRec(Last,PB^);
      if PB^[0]<>$FF then begin
       PD^[0]:=0;
       while PD^[0]<>$FF do begin Inc(First); Data^.GetRec(First,PD^) end;
       ExchRelated(Last,First);
       Data^.GetRec(Last,PB^); Data^.PutRec0(First,PB^);
       for i:=0 to Fields^.Length-1 do if IndArr[i]<>Nil
        then with IndArr[i]^ do begin Del(Last); Add(First) end;
      end;
     end;
     writeln;
     Data^.Trunc0(OpenLen); Data^.Flush;
     FreeMem(PD,RecSize); FreeMem(PB,RecSize);
  end end;
 procedure OpenThisFile;
  begin
{$IFDEF Cir}
   WriteLn(DFNR.LName+'   !');
{$ENDIF} {$IFDEF Lat}
   WriteLn(DFNR.LName+' is found ! ');
{$ENDIF}
   New(DFArr[FileCount],Open(DFNR));
   Inc(FileCount);
  end;
 procedure OpenProjFile;
  var Tail:string; wrk:string[20]; i:byte; t:text; c:integer;
  function Eat:string;
   var i:byte;
   begin
    i:=Pos(',',Tail);
    if i>0
     then begin Eat:=ClearSp(Copy(Tail,1,i-1)); System.Delete(Tail,1,i) end
     else begin Eat:=Tail; Tail:='' end;
   end;
  begin
   assign(t,ProjFileName); reset(t);
   while not eof(t) do begin
    readln(t,Tail);
    if Pos('FILE ',Tail)=1 then with DFNR do begin
     System.Delete(Tail,1,5);
     FName:=Eat; LName:=Eat; SName:=Eat;
     wrk:=Eat; Status:=2; { Error Value }
     for i:=0 to 1 do if wrk=FileStatusStr0[i] then Status:=i;
     wrk:=Eat; if wrk='' then wrk:='0';
     Val(wrk,CntSize,c);
     if CntSize<>0 then CntSize:=min(8,max(2,CntSize));
     wrk:=FName+'.fld';
     if FileExists(wrk) then OpenThisFile
      else writeln(ErrStr(esCanTFindFil)+wrk);
    end;
   end;
   System.Close(t);
  end;
 begin
  WriteLn(ErrStr(esNowIMOpenFl));
  if FileExists(ProjFileName) then OpenProjFile else begin
   writeln('File '+ProjFileName+' not found !'); Halt;
  end;
  if FileCount>0 then for i:=0 to FileCount-1 do DFArr[i]^.SetFldLinks;
  if KrunchEnabled then begin
   SetUseMode;
   KrunchFiles;
   SetDesignMode;
  end;
  SetUseMode;
 end;

end.
