program srdbd;

{$I options.pp}

uses
 str_def, common,
 sr_open, sr_conn, sr_data, sr_net;

procedure Help;
 begin
  Writeln;
  Writeln;
  Writeln(ErrStr(esSRDB_Help_0));
  Writeln;
  Writeln;
  Writeln(ErrStr(esSRDB_Help_1));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_2));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_3));
  Writeln(ErrStr(esSRDB_Help_4));
  Writeln(ErrStr(esSRDB_Help_5));
  Writeln(ErrStr(esSRDB_Help_6));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_8));
  Writeln(ErrStr(esSRDB_Help_9));
  Writeln;
  {$IFDEF Cir}
  Writeln('  /L -    -   SRDB.LOG');
  {$ENDIF}
  {$IFDEF Lat}
  Writeln('  /L or -l - Write client/server dialog to file SRDB.LOG');
  {$ENDIF}
  Writeln;
  Writeln;
  Halt;
 end;

procedure SetBufSize(s:string);
 var w:string; i,l:integer;
 begin
  w:=s; Delete(w,1,3);
  Val(w,l,i);
  if i=0 then if (l>=32) and (l<=240) then begin
   StdIndxBufLen:=l;
   StdDataBufLen:=l;
  end;
 end;

procedure AnalizeParams;
 var s:string; i,j:byte;
 begin
  Writeln;
  Writeln(ErrStr(esSRDB_Help_7));
  if paramcount>0 then for i:=1 to paramcount do begin
   s:=ParamStr(i);
   if Length(s)>0 then for j:=1 to length(s) do s[j]:=UpCase(s[j]);
   if Pos('/B:',s)>0 then SetBufSize(s);
   if Pos('/F' ,s)>0 then KrunchEnabled:=False;
   LogFileEnable:=(Pos('/L' ,s)>0) or (Pos('-L',s)>0);
   if paramstr(i)='/?' then Help;
  end;
 end;

begin
 if ErrFileInit then begin
  AnalizeParams;
  OpenBase;
  LogInit;
  RunDaemon;
{
  if not DetectLocal then begin
   OpenBase;
   NetInit;
  end else writeln('Some server is already loaded !');
}
 end;
end.
